// This file is auto-generated, don't edit it. Thanks.
package com.aliyun.sample;

import com.aliyun.tea.*;
import com.aliyun.teaconsole.*;
import com.aliyun.teautil.*;
import com.aliyun.ecs20140526.*;
import com.aliyun.ecs20140526.models.*;
import com.aliyun.teaopenapi.*;
import com.aliyun.teaopenapi.models.*;
import com.aliyun.darabonba.env.*;
import com.aliyun.darabonbastring.*;

public class Sample {

    /**
     * 使用AK&SK初始化账号Client
     * @param accessKeyId
     * @param accessKeySecret
     * @param regionId
     * @return Client
     * @throws Exception
     */
    public static com.aliyun.ecs20140526.Client Initialization(String accessKeyId, String accessKeySecret, String regionId) throws Exception {
        Config config = new Config();
        // 您的AccessKey ID
        config.accessKeyId = accessKeyId;
        // 您的AccessKey Secret
        config.accessKeySecret = accessKeySecret;
        // 您的可用区ID
        config.regionId = regionId;
        return new com.aliyun.ecs20140526.Client(config);
    }

    /**
     * 创建安全组
     * @param client
     * @param regionId
     * @param securityGroupName
     * @param vpcId
     * @throws Exception
     */
    public static String CreateSecurityGroupSample(com.aliyun.ecs20140526.Client client, String regionId, String securityGroupName, String vpcId) throws Exception {
        CreateSecurityGroupRequest request = new CreateSecurityGroupRequest()
                .setSecurityGroupName(securityGroupName)
                .setVpcId(vpcId)
                .setRegionId(regionId);
        CreateSecurityGroupResponse response = client.createSecurityGroup(request);
        com.aliyun.teaconsole.Client.log("安全组创建成功，ID:" + response.body.securityGroupId + "");
        return response.body.securityGroupId;
    }

    /**
     * 将一台ECS实例或一个弹性网卡加入到指定的安全组
     * @param client
     * @param regionId
     * @throws Exception
     */
    public static void JoinSecurityGroupSample(com.aliyun.ecs20140526.Client client, String regionId, String securityGroupId, String instanceId, String networkInterfaceId) throws Exception {
        JoinSecurityGroupRequest request = new JoinSecurityGroupRequest()
                .setRegionId(regionId)
                .setSecurityGroupId(securityGroupId)
                .setInstanceId(instanceId)
                .setNetworkInterfaceId(networkInterfaceId);
        JoinSecurityGroupResponse response = client.joinSecurityGroup(request);
        if (com.aliyun.teautil.Common.isUnset(networkInterfaceId)) {
            com.aliyun.teaconsole.Client.log("实例" + instanceId + "已加入安全组" + securityGroupId + "，RequestId: " + response.body.requestId + "");
        } else {
            com.aliyun.teaconsole.Client.log("网卡" + networkInterfaceId + "已加入安全组" + securityGroupId + "，RequestId: " + response.body.requestId + "");
        }

        return ;
    }

    public static void main(String[] args_) throws Exception {
        java.util.List<String> args = java.util.Arrays.asList(args_);
        // 区域ID
        String regionId = args.get(0);
        // 安全组名称
        String securityGroupName = args.get(1);
        // 安全组所属VPCID
        String vpcId = args.get(2);
        if (com.aliyun.teautil.Common.empty(vpcId)) {
            vpcId = null;
        }

        // 要加入的实例ID
        java.util.List<String> instanceIds = new java.util.ArrayList<>();
        if (!com.aliyun.teautil.Common.empty(args.get(3))) {
            instanceIds = com.aliyun.darabonbastring.Client.split(args.get(3), ",", -1);
        }

        // 要加入的弹性网卡ID
        java.util.List<String> networkInterfaceIds = new java.util.ArrayList<>();
        if (!com.aliyun.teautil.Common.empty(args.get(4))) {
            networkInterfaceIds = com.aliyun.darabonbastring.Client.split(args.get(4), ",", -1);
        }

        com.aliyun.ecs20140526.Client client = Sample.Initialization(com.aliyun.darabonba.env.EnvClient.getEnv("ACCESS_KEY_ID"), com.aliyun.darabonba.env.EnvClient.getEnv("ACCESS_KEY_SECRET"), regionId);
        com.aliyun.teaconsole.Client.log("--------------------创建安全组--------------------");
        String securityGroupId = Sample.CreateSecurityGroupSample(client, regionId, securityGroupName, vpcId);
        com.aliyun.teautil.Common.sleep(1000);
        for (String id : instanceIds) {
            com.aliyun.teaconsole.Client.log("--------------------添加实例" + id + "到安全组--------------------");
            Sample.JoinSecurityGroupSample(client, regionId, securityGroupId, id, null);
        }
        for (String id : networkInterfaceIds) {
            com.aliyun.teaconsole.Client.log("--------------------添加网卡" + id + "到安全组--------------------");
            Sample.JoinSecurityGroupSample(client, regionId, securityGroupId, null, id);
        }
    }
}
